package com.hithomelabs.princeton1.module4;

import java.util.Iterator;

public class ArrayStack<Item> extends Stack<Item>{

    private int capacity=3;
    private int top=0;
    private Item[] arr = (Item[]) new Object[capacity];


    @Override
    public boolean isEmpty() {
        return top == 0;
    }

    private void resize(int newCapacity){
        Item[] temp = arr;
        arr = (Item[]) new Object[newCapacity];

        for(int i=0; i<top; i++){
            arr[i]=temp[i];
        }
        capacity=newCapacity;
//        System.out.println("New Capacity: "+capacity);
    }

    @Override
    public void push(Item element) {
        if(top == capacity)
            resize(capacity * 2);
        arr[top++] = element;
    }

    @Override
    public Item pop() {

        //System.out.println(top);

        if(top == 0)
            //throw new java.util.NoSuchElementException();
            return null;

        Item element = arr[--top];
        arr[top] = null;

        if(top < capacity/4)
            resize(capacity/2);
        return element;
    }

    @Override
    public int size() {
        return top;
    }

    @Override
    public Iterator<Item> iterator() {
        return new Iterator<Item>() {
            private int current=0;
            @Override
            public boolean hasNext() {
                return current<top;
            }

            @Override
            public Item next() {
                return arr[current++];
            }
        };
    }

    public static void main(String[] args){
        Stack<Integer> s = new ArrayStack<>();

        try{
            s.push(0);
            s.push(1);
            s.push(2);
            s.push(3);
            s.push(4);
            s.push(5);
            s.push(6);
            s.push(7);

            for(Integer i: s)
                System.out.println(i);

            s.pop();
            s.pop();
            s.pop();
            s.pop();
            s.pop();
            s.pop();
            s.pop();
            s.pop();
//            s.pop();

            for(Integer i: s)
                System.out.println(i);

        } catch (java.util.NoSuchElementException e) {
            System.out.println("Cannot pop an empty stack");
        }



    }
}
