package com.hithomelabs.princeton1.module4;

import java.util.Iterator;

public class LinkedQueue<Item> extends Queue<Item>{
    private Node head = null, tail = null;
    private int size = 0;

    private class Node{
        Item value;
        Node next;
    }

    @Override
    public boolean isEmpty() {
        return size == 0;
    }

    @Override
    public Item dequeue() {
        if(size == 0)
//            throw new java.util.NoSuchElementException();
            return null;

        Item element = head.value;
        head = head.next;
        size--;
        if(isEmpty())
            tail=head;
        return element;
    }

    @Override
    public void enqueue(Item element) {
        Node newNode = new Node();
        newNode.value = element;
        newNode.next = null;
        if(isEmpty()){
            tail=newNode;
            head=tail;
        }
        else{
            tail.next = newNode;
            tail = tail.next;
        }
        size++;

    }

    @Override
    public int size() {
        return size;
    }

    @Override
    public Iterator<Item> iterator() {
        return new Iterator<Item>() {
            Node current = head;
            @Override
            public boolean hasNext() {
                return current != null;
            }

            @Override
            public Item next() {
                Item element = current.value;
                current = current.next;
                return element;
            }
        };

    }

    public static void main(String[] args){
        Queue<Integer> q = new LinkedQueue<>();

        try{
            System.out.println("Queue empty?: " + q.isEmpty());
            q.enqueue(1);
            q.enqueue(2);
            q.enqueue(3);
            q.enqueue(4);

            for(int value: q)
                System.out.println(value);

            System.out.println("Queue empty?: " + q.isEmpty());
            System.out.println("Queue Size?: " + q.size());

            q.dequeue();
            q.dequeue();
//            q.dequeue();
//            q.dequeue();
//            q.dequeue();

            for(int value: q)
                System.out.println(value);

        } catch (java.util.NoSuchElementException e) {
            System.out.println("Cannot dequeue empty queue");
        }
    }
}
