package com.hithomelabs.princeton1.module4;

import java.util.Iterator;

public class LinkedStack<Item> extends Stack<Item> {

    private Node top = null;
    private int size = 0;

    private class Node{
        Item value;
        Node next;
    }


    @Override
    public boolean isEmpty() {
        return size == 0 ;
    }

    @Override
    public void push(Item element) {
        Node newNode = new Node();
        newNode.value = element;
        newNode.next = top;
        top = newNode;
//        System.out.println(top.value);
        size++;
    }

    @Override
    public Item pop() {
        if(size == 0){
            throw new java.util.NoSuchElementException();
        }
        Item element = top.value;
        top=top.next;
        size--;

        return element;
    }

    @Override
    public int size() {
        return size;
    }

    @Override
    public Iterator<Item> iterator() {
        return new Iterator<Item>() {
            private Node current = top;
            @Override
            public boolean hasNext() {
                return current != null;
            }

            @Override
            public Item next() {
                Item element = current.value;
                current=current.next;
                return element;
            }
        };
    }

    public static void main(String[] args){
        Stack <String> s = new LinkedStack<>();

        try {
            System.out.println("String empty?: " + s.isEmpty());
//            s.pop();
            s.push("12");
            s.push("13");
            s.pop();
            s.push("14");
            System.out.println("String empty?: " + s.isEmpty());
            System.out.println("String size?: " + s.size());

            for(String value: s){
                System.out.print(value+" ");
            }
        } catch (Exception e) {
            System.out.println("Cannot pop an empty stack");
        }
    }
}
